/*-------------------------------------------------------------
  module: cauchy.C
  author: Angel L. Diaz
  date: 10/23/96

-------------------------------------------------------------*/

// arithmetic includes
#include "PlugIns/saclib.h"
#include "BlackBox/CommonObjects/bbcauchy.h"
#include "BlackBox/Aux/bbselector.h"

int main() {
   Word stack;
   SaclibInitEnv(1000000,stack);

   int NumVars  = 4;
   int Deg      = -1;
   int Prob     = 1;
   BlackBoxCauchyDet< SaclibQ > BBCauchyDet1( NumVars, Deg, Prob ); 

   SaclibQ T1[4] = { (long)1, (long)2, (long)3, (long)4 };
   cout << "BBCauchyDet1( T1 ) = " << *BBCauchyDet1( T1 ) << endl;
 
   SaclibCleanUpEnv();
}

