/*-------------------------------------------------------------
  module: bberror.h

  author: Angel L. Diaz
  date: 8/6/96

  Error conditions.
-------------------------------------------------------------*/

#define BBERROR_POLY          1
#define BBERROR_UPOLY         2
#define BBERROR_CAUCHYDET     3
#define BBERROR_GCD           10
#define BBERROR_FACTORS       20
#define BBERROR_FACTORS_HMAP  25
#define BBERROR_NUMDEN        30
#define BBERROR_SPARSE        40
#define BBERROR_FACTORY       100
#define BBERROR_SHOUP         101
#define BBERROR_SACLIB        102
#define BBERROR_PARI          103

void OutputErrorMessage(int ErrorCode, const char *ErrorMessage)
{
   switch (ErrorCode) {
      case BBERROR_POLY:
         cerr << "Error caught in : " << ErrorMessage << endl;
      break;
      case BBERROR_UPOLY:
         cerr << "Error caught in : " << ErrorMessage << endl;
      break;
      case BBERROR_GCD:
         cerr << "Error caught in : " << ErrorMessage << endl;
      break;
      case BBERROR_FACTORS:
         cerr << "Error caught in : " << ErrorMessage << endl;
      break;
      case BBERROR_FACTORS_HMAP:
         cerr << "Error caught in : " << ErrorMessage << endl;
      break;
      case BBERROR_NUMDEN:
         cerr << "Error caught in : " << ErrorMessage << endl;
      break;
      case BBERROR_FACTORY:
         cerr << "Error caught in : " << ErrorMessage << endl;
      break;
      case BBERROR_SPARSE:
         cerr << "Error caught in : " << ErrorMessage << endl;
      break;
      case BBERROR_SHOUP:
         cerr << "Error caught in : " << ErrorMessage << endl;
      break;
      case BBERROR_SACLIB:
         cerr << "Error caught in : " << ErrorMessage << endl;
      break;
      case BBERROR_PARI:
        cerr << "Error caught in : " << ErrorMessage << endl;
      break;
      default:
        cerr << "Error : " << ErrorMessage << endl;
      break;
   }
} 

void OutputErrorExit(int ErrorCode, const char* ErrorMessage)
{
   OutputErrorMessage(ErrorCode, ErrorMessage);
   exit(ErrorCode);
}
