add := proc(a,b)
local i,
      ra,rb,
      rmax,rmin,
      c;
 c := [];
 ra := nops(a);
 rb := nops(b);
 rmax := max(ra,rb);
 rmin := min(ra,rb);

 for i from 1 to rmin do c := [op(c),a[i]+b[i]]; od;
 if ( ra = rmax ) then
  for i from rmin+1 to rmax do c := [op(c),a[i]]; od;
 else
  for i from rmin+1 to rmax do c := [op(c),b[i]]; od;
 fi;

 RETURN(c); 
end;

mult := proc(a,b)
local i,k,j,
      ra,rb,
      tmp,
      c;
 c := [];
 ra := nops(a);
 rb := nops(b);

 for k from 1 to (ra + rb-1) do
  tmp := 0;
  for i from 1 to k do
     if ( (i<=ra) and ((k-i+1)<=rb) ) then
     tmp := tmp + a[i]*b[k-i+1]; 
     fi;
  od;
  c := [ op(c) , tmp ];
 od;

 RETURN(c);
end;

shadd := proc(a,b,db)
local i,
      ra,
      c;
 c := [];
 ra := nops(a);
 for i from 1 to ra do
  c := [ op(c) , a[i] ];
 od;

 if db+1 <= ra then
  c := subsop(db+1=c[db+1]+b,c);
 else
  for i from ra+1 to db do
   c := [ op(c) , 0 ];
  od;
  c := [ op(c) , b ];
 fi;

 RETURN(c);
end;

shmult := proc(a,b,db)
local i,
      ra,
      c;
 c := [];
 ra := nops(a);

 for i from 1 to db do
  c := [ op(c) , 0 ];
 od;
 for i from 1 to ra do
  c := [ op(c) , a[i]*b ];
 od;

 RETURN(c);
end;

lstcoeff := proc(a,k)
local ra;
 ra := nops(a);   
 if (k+1) > ra then RETURN(0); fi;
 RETURN(eval(a[k+1])); 
end;

chngrep := proc(a)
local ra,
      i,
      c;
 ra := nops(a);
 c := a[1];
 for i from 2 to ra do
  c := c + a[i]*Y^(i-1);
 od;
 RETURN(c); 
end;

