#include <iostream.h>

typedef int (*FPTR)();

class A 
{
 public:
  A()   { cout << "A()" << endl; value = 10; funop = (FPTR)&A::BAD;      }
  ~A()  {                                                                }
 virtual inline int operator() () { cout << "A::()" << endl;
          return (*funop)();                                             } 
 inline void PrintValue() { cout << "A::PrintValue " << value << endl;   }
 virtual inline unsigned int getsize() 
        { cout << "A::GetSize  " << sizeof(A) << endl; return sizeof(A); }
 int BAD() 
        { cout << "MUST USE A DERIVED CLASS!" << endl; exit(1);          }
 protected:
  int value;
  FPTR funop;
};

class B : public A 
{
 public:
  B()       { cout << "B() "  << sizeof(B) << endl; 
              funop = (FPTR)&B::operator();  }
  B(int v)  { value = v; cout << "B(int v)" << sizeof(B) << endl; 
              funop = (FPTR)&B::operator();  }
  ~B()      {                                                     }
  inline int operator() () 
            { cout << "B::operator()" << endl; cout.flush(); 
              z = 0; cout << z << endl; return value; }
  virtual inline unsigned int getsize() 
            {cout << "B::getsize() " << sizeof(B) << endl; return sizeof(B); }
 protected:
  int z;
  int k[100000];

};

class C : public A
{
 public:
  C()       { cout << "C()" << sizeof(C) << endl;
              funop = (FPTR)&C::operator();                       }
  C(int v)  { value = v; cout << "C(int v)" << sizeof(C) << endl; 
              funop = (FPTR)&C::operator();                       }
  ~C()      {                                                     }
  inline int operator() () 
            { cout << "C::operator()" << endl; return value; }
  virtual inline unsigned int getsize() 
            {cout << "C::getsize() " <<sizeof(C) << endl; return sizeof(C); }

 protected:
  int a[100000];
  float b[100000]; 
};

void foo(B*);
void bar(A*);

void main(void)
{

B b1(20),b2(30);
C c1(40);

b1.PrintValue();
cout << b1() << endl; 
b2.PrintValue();
cout << b2() << endl;
c1.PrintValue();
cout << c1() << endl;

cout << endl << "*** HETEROGENEOUS ARRAY (Abstract Class) ***" << endl;
A b3[3] = {(A)b1,(A)c1,(A)b2};
cout << "&b3[0] " << (unsigned int) &b3[0] << endl;
cout << "&b3[1] " << (unsigned int) &b3[1] << endl;
cout << "&b3[2] " << (unsigned int) &b3[2] << endl;
cout << "&b3    " << (unsigned int) &b3    << endl;
bar(b3);

cout << endl << "*** HOMOGENEOUS ARRAY (B Class) ***" << endl;
B b4[3] = {b1,b2,b2};
cout << "&b4[0] " << (unsigned int) &b4[0] << endl;
cout << "&b4[1] " << (unsigned int) &b4[1] << endl;
cout << "&b4[2] " << (unsigned int) &b4[2] << endl;
cout << "&b4    " << (unsigned int) &b4    << endl;
bar(b4);

foo(b4);
}

void bar(A* array)
{
unsigned int cursize,offset,base; int i;
cout << ">>>>>>>>>>>>>bar " << endl;
cout << "&array[0] " << (unsigned int) &array[0] << endl;
cout << "&array[1] " << (unsigned int) &array[1] << endl;
cout << "&array[2] " << (unsigned int) &array[2] << endl;
cout << "&array    " << (unsigned int) &array    << endl;
base = (unsigned int) &array[0];
offset = cursize = ((A*)(base))->getsize();
cout << "&array[0]         " << base << endl;
cout << "size of array[0]  " << cursize << endl;
((A*)base)->PrintValue();
(*((A*)(base)))();
for(i=1;i<3;i++)
 {
  cout << "&array[" << i << "]        " << base + offset << endl;
  cursize = ((A*)(base+offset))->getsize();
  ((A*)(base+offset))->PrintValue();
  (*((A*)(base+offset)))();
  cout << "size of array[" << i << "] "  << cursize << endl;
  offset = offset + cursize;
 }
}
void foo(B* array)
{
unsigned int cursize,offset,base; int i;
cout << ">>>>>>>>>>>>>foo " << endl;
cout << "&array[0] " << (unsigned int) &array[0] << endl;
cout << "&array[1] " << (unsigned int) &array[1] << endl;
cout << "&array[2] " << (unsigned int) &array[2] << endl;
cout << "&array    " << (unsigned int) &array    << endl;
base = (unsigned int) &array[0];
offset = cursize = ((B*)(base))->getsize();
cout << "&array[0]         " << base << endl;
cout << "size of array[0]  " << cursize << endl;
((B*)base)->PrintValue();
(*((B*)(base)))();
for(i=1;i<3;i++)
 {
  cout << "&array[" << i << "]        " << base + offset << endl;
  cursize = ((B*)(base+offset))->getsize();
  ((B*)(base+offset))->PrintValue();
  (*((B*)(base+offset)))();
  cout << "size of array[" << i << "] "  << cursize << endl;
  offset = offset + cursize;
 }
}

