#include <iostream.h>

class A 
{
 public:
  A()   { cout << "A()" << endl; value = 10; }
  ~A()  { cout << "~A()" << endl; }
 virtual inline int operator() () = 0;
 inline void PrintValue() { cout << "A::PrintValue " << value << endl; }
 virtual inline unsigned int size() = 0;

 protected:
  int value;
};

class B : public A 
{
 public:
 B()       { cout << "B()" << endl;                 }
 B(int v)  { cout << "B(int v)" << endl; value = v; }
 ~B()      { cout << "~B()" << endl;                }
 inline int operator() () 
           { cout << "B::operator()" << endl; return value; }
 virtual inline unsigned int size() { return sizeof(B); }
 int k[100000];

};

void foo(B*);
void bar(A*);

void main(void)
{

B b1(20),b2(30);

b1.PrintValue();
cout << b1() << endl; 
b2.PrintValue();
cout << b2() << endl;

B b3[2] = {b1,b2};
cout << "&b3[0] " << &b3[0] << endl;
cout << "&b3[1] " << &b3[1] << endl;
cout << "&b3    " << &b3    << endl;

foo(b3);
bar(b3);

}

void foo(B* b3)
{
unsigned int size,base;
cout << "foo " << endl; 
cout << "&b3[0] " << &b3[0] << " as an int " << (unsigned int) &b3[0] << endl;
cout << "&b3[1] " << &b3[1] << " as an int " << (unsigned int) &b3[1] << endl;
size = b3[0].size();
base = (unsigned int) &b3[0];
cout << "size of b3[0] " << size << " base of b3 is " << base << endl;
cout << "&b3[0] " << &b3[0] << endl;
cout << "&b3[1] " << base+size << endl;
((B*)(base+size))->PrintValue();
(*((B*)(base+size)))();

}

void bar(A* b3)
{
unsigned int size,base;
cout << "bar " << endl;
cout << "&b3[0] " << &b3[0] << endl;
cout << "&b3[1] " << &b3[1] << endl;
cout << "&b3    " << &b3    << endl;
size = b3[0].size();
base = (unsigned int) &b3[0];
cout << "size of b3[0] " << size << " base of b3 is " << base << endl;
cout << "&b3[0] " << &b3[0] << endl;
cout << "&b3[1] " << base+size << endl;
((A*)(base+size))->PrintValue();
(*((A*)(base+size)))();
}
