readlib(procmake):
bbpolygen := proc(poly,varlist)
 local box,      # neutral form of black box procedure
       varlen;   # length of the list of indeterminants

       varlen  := nops(varlist);
       box := `&proc`([pnts], [p,i,n,vl] , [] ,
                            `&statseq`(
                                        `&:=`(`&local`[1], poly),
                                        `&:=`(`&local`[3], varlen),
                                        `&:=`(`&local`[4], varlist),
                                        `&:=`(`&local`[1],
                                        'subs(seq(vl[`&local`[2]]=`&args`[1]
                                          [`&local`[2]],
                                          `&local`[2]=1..`&local`[3]),p)'),
                                        `&RETURN`(`&local`[1])
                                      )
                     );

 RETURN(procmake(box));
end:

bbnumgen := proc(bbnumden)
 local box;      # neutral form of black box procedure

       box := `&proc`([pnts], [bb] , [] ,
                            `&statseq`(
                                       `&:=`(`&local`[1], eval(bbnumden)),
                                        `&RETURN`(`&local`[1](pnts)[1])
                                      )
                     );
 RETURN(procmake(box));
end:

bbdengen := proc(bbnumden)
 local box;      # neutral form of black box procedure

       box := `&proc`([pnts], [bb] , [] ,
                            `&statseq`(
                                       `&:=`(`&local`[1], eval(bbnumden)),
                                        `&RETURN`(`&local`[1](pnts)[2])
                                      )
                     );
 RETURN(procmake(box));
end:

bbcall := proc(bb,pnts,n)
 local i,npnts;

    npnts := array(1..n-1);
    for i from 2 to n do
     npnts[i-1] := pnts[i]*pnts[1];
    od;

 RETURN(bb(npnts));
end:

