readlib(procmake):
bbpolygen := proc(poly,varlist)
 local box,      # neutral form of black box procedure
       varlen;   # length of the list of indeterminants

       varlen  := nops(varlist);
       box := `&proc`([pnts,m], [p,i,n,vl] , [] ,
                            `&statseq`(
                                        `&:=`(`&local`[1], poly),
                                        `&:=`(`&local`[3], varlen),
                                        `&:=`(`&local`[4], varlist),
                                        `&:=`(`&local`[1],
                                        'subs(seq(vl[`&local`[2]]=`&args`[1]
                                          [`&local`[2]],
                                          `&local`[2]=1..`&local`[3]),p) mod m'),
                                        `&RETURN`(`&local`[1])
                                      )
                     );

 RETURN(procmake(box));
end:

bbcall := proc(bb,pnts,n,m)
 local i,npnts;

    npnts := array(1..n-1);
    for i from 2 to n do
     npnts[i-1] := modp( pnts[i]*pnts[1], m);
    od;

 RETURN(bb(npnts,m));
end:

