
#ifndef vec_ZZ__H
#define vec_ZZ__H

#include "ZZ.h"
#include "Vector.h"

Vector_decl(ZZ)

Vector_eq_decl(ZZ)

Vector_io_decl(ZZ)

void mul(Vector(ZZ)& x, const Vector(ZZ)& a, const ZZ& b);
void add(Vector(ZZ)& x, const Vector(ZZ)& a, const Vector(ZZ)& b);

void sub(Vector(ZZ)& x, const Vector(ZZ)& a, const Vector(ZZ)& b);
void clear(Vector(ZZ)& x);
void negate(Vector(ZZ)& x, const Vector(ZZ)& a);




void InnerProduct(ZZ& x, const Vector(ZZ)& a, const Vector(ZZ)& b);


#endif
