
#ifndef vec_zz_p__H
#define vec_zz_p__H

#include "vec_ZZ.h"
#include "lzz_p.h"
#include "Vector.h"

Vector_decl(zz_p)

Vector_io_decl(zz_p)

Vector_eq_decl(zz_p)

void operator<<(Vector(zz_p)& x, const Vector(ZZ)& a);
void operator<<(Vector(ZZ)& x, const Vector(zz_p)& a);
long CRT(Vector(ZZ)& g, ZZ& a, const Vector(zz_p)& G);

void add(Vector(zz_p)& x, const Vector(zz_p)& a, const Vector(zz_p)& b);

void sub(Vector(zz_p)& x, const Vector(zz_p)& a, const Vector(zz_p)& b);
void clear(Vector(zz_p)& x);
void negate(Vector(zz_p)& x, const Vector(zz_p)& a);






void InnerProduct(zz_p& x, const Vector(zz_p)& a, const Vector(zz_p)& b);
void InnerProduct(zz_p& x, const Vector(zz_p)& a, const Vector(zz_p)& b,
                  long offset);

void mul(Vector(zz_p)& x, const Vector(zz_p)& a, zz_p b);



#endif
