
#ifndef ZZXIntPair__H
#define ZZXIntPair__H

#include "ZZX.h"
#include "vector.h"

struct ZZXIntPair {
   ZZX g;
   long k;
};


istream& operator>>(istream& s, ZZXIntPair& x);

ostream& operator<<(ostream& s, const ZZXIntPair& x);


vector_decl(ZZXIntPair)

vector_io_decl(ZZXIntPair)

void Append(vector(ZZXIntPair)& x, const ZZX& g, long k);


#endif
