
#ifndef vec_zz_p__H
#define vec_zz_p__H

#include "vec_ZZ.h"
#include "zz_p.h"
#include "vector.h"

vector_decl(zz_p)

vector_io_decl(zz_p)

vector_eq_decl(zz_p)

void operator<<(vector(zz_p)& x, const vector(ZZ)& a);
void operator<<(vector(ZZ)& x, const vector(zz_p)& a);



void InnerProduct(zz_p& x, const vector(zz_p)& a, const vector(zz_p)& b);
void InnerProduct(zz_p& x, const vector(zz_p)& a, const vector(zz_p)& b,
                  long offset);


#endif
