
sint :=
proc(f,x,t,p)
local a,b,c,d,e,i,j,k,l,m,n,r,u,v,z;
options `Copyright 1993 by Waterloo Maple Software`;
    if type(x,name) then RETURN(sinterp(f,[x],d,p)) fi;
    if not type(f,procedure) and type(x,list) and type(t,integer) or t < 0 or
        not type(p,integer) then
        ERROR(`invalid arguments`)
    fi;
    printf(`Starting sparse interpolation\n`);
    n := nops(x);
    for i to n do
        d[i] := readlib(dinterp)(f,n,i,t,p);
        if d[i] = FAIL then RETURN(FAIL) fi
    od;
    r := rand(p);
    v := ['r()' $ n];
    c := 0;
    printf(`Starting variable by variable interpolation\n`);
    printf(`number of variables     : %a\n`,n);
    printf(`variable list           : %a\n`,x);
    printf(`estimated degrees       : %a\n`,eval(d));
    printf(`bound on total degree   : %a\n`,t);
    printf(`random initial points   : %a\n`,v);
    printf(`interpolated polynomial : %a\n`,c);
    for i to n do
        printf(`**** Interpolating variable       : %a to degree %a\n`,
                x[i],d[i]);
        if type(c,`+`) then c := {op(c)} else c := {c} fi;
        if c = {0} then c := {1} fi;
        printf(`interpolated polynomial           : %a\n`,c);
        printf(`number of terms in polynomial now : %a\n`,nops(c));
        userinfo(2,sinterp,`number of terms in polynomial now`,nops(c),
            lprint('interpolating',x[i],`to degree`,d[i]),
            lprint(`maximum # of equations required`,nops(c)*(d[i]+1)));
        m := 0;
        a := table();
        for j to nops(c) do
            printf(`d[%d]                              : %a\n`,i,d[i]);
            printf(`c[%d]                              : %a\n`,j,c[j]);
            printf(`degree(c[%d])                      : %a\n`,j,degree(c[j]));
            l := min(d[i],t-degree(c[j]));
            printf(`l                                 : %a\n`,l);
            m := m+l+1;
            printf(`m                                 : %a\n`,m); 
            a[j] := c[j]*b[j,k]*x[i]^k $ (k = 0 .. l);
            printf(`a[%d]                             : %a\n`,j,[a[j]]);
            a[j] := convert([a[j]],`+`);
            printf(`a[%d]                             : %a\n`,j,a[j]);
        od;
        userinfo(2,sinterp,`number of equations generated`,m);
        v := subsop(1 = NULL,v);
        a := convert([a[k] $ (k = 1 .. nops(c))],`+`);
        u := indets(a) minus {op(x)};
        printf(`truncated initial point list      : %a\n`,v);
        printf(`a                                 : %a\n`,a);
        printf(`u                                 : %a\n`,u);
        printf(`m                                 : %a\n`,m);
        e := table();
        for j to m do
            z := ['r()' $ i];
            printf(`random points for known variables : %a\n`,z);
            printf(`new variable list                 : %a\n`,[op(z),op(v)]);
            e[j] := traperror(f(op(z),op(v),p));
            printf(`evaluation                        : %a\n`,e[j]);
            if e[j] = lasterror then RETURN(FAIL) fi;
            z := {(x[k] = z[k]) $ (k = 1 .. i)};
            printf(`z                                 : %a\n`,z);
            e[j] := (subs(z,a)-e[j]) mod p;
            printf(`e[%d]                              : %a\n`,j,e[j]);
        od;
        e := {e[k] $ (k = 1 .. m)};
        printf(`e                                 : %a\n`,e);
        printf(`u                                 : %a\n`,u);
        printf(`readlib(msolve/linear)(e,u,p)     : %a\n`,
               readlib(`msolve/linear`)(e,u,p));
        printf(`a                                 : %a\n`,a);
        c := subs(readlib(`msolve/linear`)(e,u,p),a) mod p;
        if has(c,u) then RETURN(FAIL) fi;
        printf(`c                                 : %a\n`,c);
    od;
    RETURN(c)
end;

