raise := proc(p,e,d,i,m)
local j,prod;

   if i = 1 then
    prod := modp( p[1]^d, m); 
   else
    prod := modp( p[1]^e[1], m); 
    for j from 2 to i-1 do
     prod := modp( prod*(p[j]^e[j]), m);
    od;
    prod := modp( prod*p[i]^d , m);
   fi;

 RETURN(prod);
end:

nextJi := proc(x,nJi,k)
local i,Ji;

   Ji := [];
   for i from 1 to k do
     if x[i] <> 0 then
       Ji := [ op(Ji), nJi[i] ];
     fi;  
   od;

 RETURN(Ji);
end:

buildpoly := proc(x,nJi,k,vars,n,modulus)
local i,j,poly,m;

   poly := 0;
   for i from 1 to k do
    if x[i] <> 0 then
      m := 1;
      for j from 1 to n do
       m := m*vars[j]^nJi[i][j];
      od; 
      poly := modp( poly + x[i]*m, modulus);
    fi;
   od;

 RETURN(poly);
end:

expdeg := proc(exp,i)
local j,d;

   d := exp[1];
   for j from 2 to i do
     d := d + exp[j];
   od;

 RETURN(d);
end:
