raise := proc(y,e,k,m)
local i,prod;

   if k = 0 then 
     prod := modp( y[1], m);
   else
     prod := modp( y[1]^e[1], m); 
   fi;
   for i from 2 to k do
    prod := modp( prod*(y[i]^e[i]), m);
   od;

 RETURN(prod);
end:

getexps := proc(monlst,vars,k,T)
local i,
      exps;
 
   exps := [];
   for i from 1 to T do
    exps := [ op(exps), getexpsaux(monlst[i],vars,k) ];
   od;

 RETURN(exps);
end:

getexpsaux := proc(mon,vars,k)
local i,
      exp;

   exp := [];
   for i from 1 to k do
     exp := [ op(exp), degree(mon,vars[i]) ];
   od;

 RETURN(exp);
end:

buildpoly :=proc(incpoly,poly,vars,exps,k,m)
local bpoly,cpoly,i,ii;

   if (k = 0) then RETURN(convert(poly,`+`)); fi;
   bpoly := 1;
   for i from 1 to k do bpoly := modp( bpoly*vars[i]^exps[i], m); od;

   cpoly := 0;
   for i from 1 to nops(poly) do; cpoly := modp( cpoly + poly[i], m); od; 
   bpoly := modp( incpoly + bpoly*cpoly, m);

 RETURN(bpoly);
end:
